%read WAV file as data and fs before run the code
N = 16384;
df = fs/N
div = 8;
BW = 30000; %Bandwidth for Doppler shift

index = 1;
c = 1;
ds = zeros(ceil(length(data)/N*div),9);

while true

    sample1 = data(index:index+N, 1) .* flattopwin(N+1) / N;
    sample2 = data(index:index+N, 2) .* flattopwin(N+1) / N;

    fft_sample = fftshift( fft( sample1 + sample2*i ) );

    %remaining within the band width
    fft_sample( 1 : N/2+1 - round(BW/df/2)   ) = 0;
    fft_sample( N/2+1 + round(BW/df/2) : N+1 ) = 0;
    
    [M,I] = max(fft_sample);

    ds(c,1) = (index-1)/fs;
    ds(c,2) = (I-(N/2+1))*df;
    ds(c,3) = abs(M);
    c = c + 1;
    
    next_index = index + N/div;

    %print progress
    if( fix(index / length(data) * 100) ~= fix( next_index / length(data) * 100) )
        progress = fix(next_index / length(data) * 100)
    end
    
    index = next_index;    
    if(index + N > length(data))
        break
    end
    
end